import request from '@/utils/request';
import type { ApiResult, PageResult } from '@/api/index';
import type { GoodsSpec, GoodsSpecParam } from './model';
import { MODULES_API_URL } from '@/config/setting';

/**
 * 分页查询商品多规格
 */
export async function pageGoodsSpec(params: GoodsSpecParam) {
  const res = await request.get<ApiResult<PageResult<GoodsSpec>>>(
    MODULES_API_URL + '/shop/goods-spec/page',
    {
      params
    }
  );
  if (res.data.code === 0) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 查询商品多规格列表
 */
export async function listGoodsSpec(params?: GoodsSpecParam) {
  const res = await request.get<ApiResult<GoodsSpec[]>>(
    MODULES_API_URL + '/shop/goods-spec',
    {
      params
    }
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 添加商品多规格
 */
export async function addGoodsSpec(data: GoodsSpec) {
  const res = await request.post<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-spec',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 修改商品多规格
 */
export async function updateGoodsSpec(data: GoodsSpec) {
  const res = await request.put<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-spec',
    data
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 删除商品多规格
 */
export async function removeGoodsSpec(id?: number) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-spec/' + id
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 批量删除商品多规格
 */
export async function removeBatchGoodsSpec(data: (number | undefined)[]) {
  const res = await request.delete<ApiResult<unknown>>(
    MODULES_API_URL + '/shop/goods-spec/batch',
    {
      data
    }
  );
  if (res.data.code === 0) {
    return res.data.message;
  }
  return Promise.reject(new Error(res.data.message));
}

/**
 * 根据id查询商品多规格
 */
export async function getGoodsSpec(id: number) {
  const res = await request.get<ApiResult<GoodsSpec>>(
    MODULES_API_URL + '/shop/goods-spec/' + id
  );
  if (res.data.code === 0 && res.data.data) {
    return res.data.data;
  }
  return Promise.reject(new Error(res.data.message));
}
